/// <reference path="../../libs/js/action.js" />
/// <reference path="../../libs/js/stream-deck.js" />
/**
 * The first event fired when Stream Deck starts
 */

const clientId = Date.now()
var statemachineInfo = ''
getStatemachine()

function getStatemachine() {
  if (baseURL) {
    request('/mwapi/statemachine', {
      body: {
        client: clientId
      }
    }).then(data => {
      if (data.status === 0) {




        getStatemachineScene(data)

        getStatemachineGfxChange(data)

        getStatemachineStreamChange(data)

        getStatemachineReplayChange(data)

        getStatemachineVolumeConfigChange(data)

        getStatemachinePtzChange(data)

        getAudioMixerChange(data)

      }
      this.delayGetStatemachine()
    }).catch(err => {
      this.delayGetStatemachine()
    });
  } else {
    this.delayGetStatemachine()
  }

}

function delayGetStatemachine() {
  setTimeout(() => {
    getStatemachine()
  }, 2000)
}


var pluginAction = null,
  uuid = '',
  oValueSelector = document.querySelector(".setvalueSelect"),
  setGlobalSettings = {},
  actionInfo = {},
  specificSelScene = ''


if ($PI) {
  $PI.onConnected((jsonObj) => {
    console.log('$PI', $PI.localization)
    uuid = jsonObj['uuid'];
    actionInfo = jsonObj.actionInfo
    if (jsonObj.hasOwnProperty('actionInfo')) {
      pluginAction = jsonObj.actionInfo['action'];
    }

    // 场景
    if (pluginAction === 'com.magewell.magewell-director.scene') {
      // action 获取内部存储数据
      getSceneActionInfo(actionInfo)
    }









    if (pluginAction === 'com.magewell.magewell-director.specific-scene') {
      specificSelScene = actionInfo.payload.settings[actionInfo.context]
      setGlobalSettings = {
        ...actionInfo.payload.settings
      }
      if (actionInfo.payload.settings.hasOwnProperty('baseURL')) {
        baseURL = actionInfo.payload.settings.baseURL
      }
      if (actionInfo.payload.settings.hasOwnProperty('sceneList')) {
        sceneList = actionInfo.payload.settings.sceneList
      }

      setDomByAction()
    }

    if (pluginAction === 'com.magewell.magewell-director.turn-on-off-gfx') {
      // action 获取内部存储数据
      getGfxActionInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.start-stop-live-streaming') {
      getStreamActionInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.turn-on-off-gfx') {
      // action 获取内部存储数据
      getGfxActionInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.set-transition-duration') {
      getTransitionActionInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.set-transition-effect') {
      getTransitionEffectInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.set-ftb-transition-duration') {
      getTransitionFtbActionInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.adjust-team-score') {
      getTeamScoreScoreboardActionInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.adjust-game-time') {
      gameTimeScoreboardActionInfo(actionInfo)
    }
    if (pluginAction === 'com.magewell.magewell-director.adjust-out-baseball') {
      adjustOutBaseballActionInfo(actionInfo)
    }
    if (pluginAction === 'com.magewell.magewell-director.adjust-ball-strike-baseball') {
      adjustBallStrikeBaseballActionInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.volume-set-volume') {
      volumeSetVolumeActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.volume-set-state') {
      volumeSetStateActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.volume-set-monitor-device') {
      volumeSetMonitorDeviceActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.volume-monitor-mic-input') {
      volumeMonitorMicInputActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-select-ptz-device') {
      ptzSelectPtzDeviceActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-go-to-preset') {
      ptzGoToPresetActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-store-preset') {
      ptzStorePresetActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-zoom-in') {
      ptzZoomInActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-zoom-out') {
      ptzZoomOutActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-focus-far') {
      ptzFocusFarActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-focus-near') {
      ptzFocusNearActionGetInfo(actionInfo)
    }


    if (pluginAction === 'com.magewell.magewell-director.ptz-move-up') {
      ptzMoveUpActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-move-up-left') {
      ptzMoveUpLeftActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-move-left') {
      ptzMoveLeftActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-move-down-left') {
      ptzMoveDownLeftActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-move-down') {
      ptzMoveDownActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-move-down-right') {
      ptzMoveDownRightActionGetInfo(actionInfo)
    }


    if (pluginAction === 'com.magewell.magewell-director.ptz-move-right') {
      ptzMoveRightActionGetInfo(actionInfo)
    }


    if (pluginAction === 'com.magewell.magewell-director.ptz-move-up-right') {
      ptzMoveUpRightActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-set-human-tracking-mode') {
      ptzSetHumanTrackingModeActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-set-human-tracking-speed') {
      ptzSetHumanTrackingSpeedActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.ptz-set-human-tracking-type') {
      ptzWakeUpCameraActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.replay-enter-replay-mode') {
      replayEnterReplayModeActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.replay-from-seconds-ago') {
      replayFormSecondsAgoActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.replay-last-event') {
      replayLastEventActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.replay-event') {
      replayEventActionInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.replay-seek') {
      replaySeekActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.replay-add-event') {
      replayAddEventActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.replay-set-speed') {
      replaySetSpeedActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.replay-select-lens') {
      replayLensActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.graphics-scale') {
      graphicsScaleActionGetInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.system-set-usbc-mode') {
      getUsbModeActionInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.set-base-runners-baseball') {
      setBaseRunnerBaseballActionInfo(actionInfo)
    }

    if (pluginAction === 'com.magewell.magewell-director.set-stoppage-time') {
      setStoppageTimeActionInfo(actionInfo)
    }
    $PI.getGlobalSettings()
  });
}

// 弹窗填写的ip
const channel = new BroadcastChannel('myChannel');
channel.addEventListener('message', (event) => {

  baseURL = event.data
  const payload = {
    baseURL: baseURL
  }
  isShowBaseURL()
  $PI.setGlobalSettings(payload)

});

// 全局的信息变更
$PI.onDidReceiveGlobalSettings((e) => {
  const payload = e.payload
  const setting = payload.settings

  if (setting.hasOwnProperty('baseURL')) {
    baseURL = setting.baseURL

    let payloadP = {
      baseURL: baseURL
    }
    if (pluginAction === 'com.magewell.magewell-director.specific-scene') {
      if (setting.hasOwnProperty('sceneList')) {
        sceneList = setting.sceneList
        payloadP.sceneList = setting.sceneList
      }
    }

    if (pluginAction === 'com.magewell.magewell-director.turn-on-off-gfx') {
      if (setting.hasOwnProperty('sceneList')) {
        gfxList = setting.gfxList
        payloadP.gfxList = setting.gfxList
      }
    }

    if (pluginAction === 'com.magewell.magewell-director.start-stop-live-streaming') {
      if (setting.hasOwnProperty('serverList')) {
        serverList = setting.serverList
        payloadP.serverList = setting.serverList
      }
    }

    payloadP = {
      ...payloadP,
      ...setGlobalSettings
    }

    // 将部分列表信息存储到每个按键
    $PI.send(uuid,
    'setSettings', {
      action: pluginAction,
      payload: payloadP || {}
    }, false)
  }
  isShowBaseURL()
})


// 打开输入ip的弹窗
let openIpWindow = document.getElementById('open-get-ip-window');

openIpWindow.addEventListener('click', () => {
  window.open(`../template/setup/index.html`);
})

// 是否展示ip地址
function isShowBaseURL() {
  var openIpDoc = document.getElementById('open-get-ip-window')
  if (baseURL) {
    openIpDoc.innerHTML = `IP: ${baseURL} </br> Change IP Address`
  } else {
    openIpDoc.innerHTML = `Input IP Address`
  }
}
