function setScoreboard() {
  let payloadP = {
    baseURL: baseURL
  }
  if (pluginAction === 'com.magewell.magewell-director.adjust-team-score' ||
      pluginAction === 'com.magewell.magewell-director.adjust-game-time' ||
      pluginAction === 'com.magewell.magewell-director.adjust-out-baseball' ||
      pluginAction === 'com.magewell.magewell-director.set-stoppage-time'
    ) {
    payloadP = {
      ...payloadP,
      ...setGlobalSettings
    }
  }
  if (pluginAction === 'com.magewell.magewell-director.adjust-ball-strike-baseball'
    ) {
    payloadP = {
      ...payloadP,
      ...setGlobalSettings
    }
  }
  if (pluginAction === 'com.magewell.magewell-director.set-base-runners-baseball'
    ) {
    payloadP = {
      ...payloadP,
      ...setGlobalSettings
    }
    }
  $PI.send(uuid,
    'setSettings', {
      action: pluginAction,
      payload: payloadP || {}
    }, false)
}


function changeTeamForm (payload) {
  setGlobalSettings = {
    ...payload
  }

  setScoreboard()
}

// 记分牌主客队计分  start==========================================
var teamNameList = [
  { label: 'home', value: 'home' },
  { label: 'guest', value: 'guest' }]
var selTeamNameId = 'home'
var selTeamScore = 0

function getTeamScoreScoreboardActionInfo(actionInfo) {
  setGlobalSettings = {
    ...actionInfo.payload.settings
  }

  if (actionInfo.payload.settings.hasOwnProperty('baseURL')) {
    baseURL = actionInfo.payload.settings.baseURL
  }

  if (actionInfo.payload.settings.hasOwnProperty(actionInfo.context)) {
    selTeamNameId = actionInfo.payload.settings[actionInfo.context].team
    selTeamScore = actionInfo.payload.settings[actionInfo.context].score
  }

  setDomByTeamScoreScoreboardAction()
}
function setDomByTeamScoreScoreboardAction() {
  document.getElementById('content').innerHTML = `
    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.scoreboard.teamName} </div>
      <select class="sdpi-item-value select setvalueSelect" id="scoreboardOptionSel">
      </select>
    </div>

    <div type="range" class="sdpi-item">
      <div class="sdpi-item-label"> ${$PI.localization.scoreboard.score}</div>
      <div class="sdpi-item-value">
          <span class="clickable" value=-100>-100</span>
          <input class="floating-tooltip" data-suffix="" type="range" id="scoreboard-team-score" min="-100" max="100" step="1" value="${ftbTransitionDuration}">
          <span class="clickable" value="100">100</span>
      </div>
    </div>
  `;

  var reg_select = document.getElementById('scoreboardOptionSel'); //找到select标签
  reg_select.innerHTML = ''
  var frag = document.createDocumentFragment(); //创建文档片段，文档片段的作用就是让for循环中创建的标签先放到文档片段中，待for循环结束后直接将文档片段插入制定的标签元素内，可以减少dom的操作
  for (var i = 0; i < teamNameList.length; i++) {
    var option = document.createElement("option"); //创建option标签
    option.value = teamNameList[i].value; //设置正在创建的option的value属性
    option.innerHTML = $PI.localization.scoreboard[teamNameList[i].label]
    if (selTeamNameId === teamNameList[i].value) {
      option.selected = true
    }
    reg_select.appendChild(option); //将设置好的 option插入文档片段。
  }
  reg_select.appendChild(frag); //循环结束后一次性，将文档片段插入制定的dom中


  const element = document.getElementById('scoreboardOptionSel');
  element.addEventListener('change', sendTeamScoreScoreboardPlugin);


  initToolTips();
  document.getElementById('scoreboard-team-score').addEventListener('input', scoreboardTeamScoreChanged);
}

function sendTeamScoreScoreboardPlugin(event) {
  const value = event.target.value

  oValueSelector && Array.prototype.forEach.call(oValueSelector.options, function (o) {
    const val = Math.round(value);
    if (o.value !== val) {
      oValueSelector.value = val;
    }
  })
  selTeamNameId = value
  if ($PI) {
    const payload = {
      [actionInfo.context]: {
        team: value,
        score: selTeamScore
      }
    }

    changeTeamForm(payload)
  }
}

function scoreboardTeamScoreChanged(event) {
  const value = event.target.value
  selTeamScore = value
  if ($PI) {
    const payload = {
      [actionInfo.context]: {
        team: selTeamNameId,
        score: value
      }
    }
    changeTeamForm(payload)
  }
}


// 记分牌主客队计分  end==========================================

// 设置比赛时间 start==========================
var gameTimeScoreboard = ''

// action 获取内部存储数据
function gameTimeScoreboardActionInfo(actionInfo) {
  gameTimeScoreboard = actionInfo.payload.settings[actionInfo.context]
  setGlobalSettings = {
    ...actionInfo.payload.settings
  }

  if (actionInfo.payload.settings.hasOwnProperty('baseURL')) {
    baseURL = actionInfo.payload.settings.baseURL
  }

  setDomGameTimeScoreboardAction()
}

function setDomGameTimeScoreboardAction() {
  setScoreboard()

  document.getElementById('content').innerHTML = `
    <div type="range" class="sdpi-item">
      <div class="sdpi-item-label"> ${$PI.localization.scoreboard.timeLengths}</div>
      <div class="sdpi-item-value">
          <span class="clickable" value=0>0</span>
          <input class="floating-tooltip" data-suffix="s" type="range" id="game-Time-scoreboard-input" min="0" max="1000" step="1" value="${gameTimeScoreboard}">
          <span class="clickable" value="1000">1000</span>
      </div>
    </div>
  `;

  initToolTips();

  document.getElementById('game-Time-scoreboard-input').addEventListener('input', gameTimeScoreboardChanged);

}

function gameTimeScoreboardChanged(event) {
  const value = event.target.value

  if ($PI) {
    const payload = {
      [actionInfo.context]: value
    }

    setGlobalSettings = {
      ...payload
    }
    setScoreboard()
  }
}

// 设置比赛时间 end==========================


// 修改棒球出局数 start==========================
var adjustOutBaseball = ''

// action 获取内部存储数据
function adjustOutBaseballActionInfo(actionInfo) {
  adjustOutBaseball = actionInfo.payload.settings[actionInfo.context]
  setGlobalSettings = {
    ...actionInfo.payload.settings
  }

  if (actionInfo.payload.settings.hasOwnProperty('baseURL')) {
    baseURL = actionInfo.payload.settings.baseURL
  }

  setDomAdjustOutBaseballAction()
}

function setDomAdjustOutBaseballAction() {
  setScoreboard()

  document.getElementById('content').innerHTML = `
    <div type="range" class="sdpi-item">
      <div class="sdpi-item-label"> ${$PI.localization.scoreboard.number}</div>
      <div class="sdpi-item-value">
          <span class="clickable" value=-2>-2</span>
          <input class="floating-tooltip" data-suffix="" type="range" id="adjust-out-baseball-input" min="-2" max="2" step="1" value="${adjustOutBaseball}">
          <span class="clickable" value="2">2</span>
      </div>
    </div>
  `;

  initToolTips();

  document.getElementById('adjust-out-baseball-input').addEventListener('input', adjustOutBaseballChanged);

}

function adjustOutBaseballChanged(event) {
  const value = event.target.value

  if ($PI) {
    const payload = {
      [actionInfo.context]: value
    }

    setGlobalSettings = {
      ...payload
    }

    setScoreboard()
  }
}

// 修改棒球出局数 end==========================


// 修改棒球投球数  start==========================================
var ballChangeBaseball = 0
var strikeChangeBaseball = 0

function adjustBallStrikeBaseballActionInfo(actionInfo) {
  setGlobalSettings = {
    ...actionInfo.payload.settings
  }

  if (actionInfo.payload.settings.hasOwnProperty('baseURL')) {
    baseURL = actionInfo.payload.settings.baseURL
  }

  if (actionInfo.payload.settings.hasOwnProperty(actionInfo.context)) {
    ballChangeBaseball = actionInfo.payload.settings[actionInfo.context].ballChange
    strikeChangeBaseball = actionInfo.payload.settings[actionInfo.context].strikeChange
  }

  setDomByadjustBallStrikeAction()
}
function setDomByadjustBallStrikeAction() {
  document.getElementById('content').innerHTML = `
    <div type="range" class="sdpi-item">
      <div class="sdpi-item-label" [data-localize]="SetFtbTransitionEffect"> ${$PI.localization.scoreboard.ballNumber}</div>
      <div class="sdpi-item-value">
          <span class="clickable" value=-3>-3</span>
          <input class="floating-tooltip" data-suffix="" type="range" id="ball-change-baseball" min="-3" max="3" step="1" value="${ballChangeBaseball}">
          <span class="clickable" value="3">3</span>
      </div>
    </div>

    <div type="range" class="sdpi-item">
      <div class="sdpi-item-label" [data-localize]="SetFtbTransitionEffect"> ${$PI.localization.scoreboard.strikeNumber}</div>
      <div class="sdpi-item-value">
          <span class="clickable" value=-2>-2</span>
          <input class="floating-tooltip" data-suffix="" type="range" id="strike-change-baseball" min="-2" max="2" step="1" value="${strikeChangeBaseball}">
          <span class="clickable" value="2">2</span>
      </div>
    </div>
  `;

  initToolTips();
  document.getElementById('ball-change-baseball').addEventListener('input', ballChangeBaseballChanged);
  document.getElementById('strike-change-baseball').addEventListener('input', strikeChangeBaseballChanged);

}

function ballChangeBaseballChanged(event) {
  const value = event.target.value

  oValueSelector && Array.prototype.forEach.call(oValueSelector.options, function (o) {
    const val = Math.round(value);
    if (o.value !== val) {
      oValueSelector.value = val;
    }
  })
  ballChangeBaseball = value
  if ($PI) {
    const payload = {
      [actionInfo.context]: {
        ballChange: value,
        strikeChange: strikeChangeBaseball
      }
    }

    changeTeamForm(payload)
  }
}

function strikeChangeBaseballChanged(event) {
  const value = event.target.value
  strikeChange = value

  if ($PI) {
    const payload = {
      [actionInfo.context]: {
        ballChange: ballChangeBaseball,
        strikeChange: value
      }
    }
    changeTeamForm(payload)
  }
}

// 修改棒球投球数  end==========================================


// 跑垒设置 start==========================
var basePositionList = [
  { label: 1, value: 1 },
  { label: 2, value: 2 },
  { label: 3, value: 3 }]

var touchBaseList = [
  { label: 'ON', value: true },
  { label: 'OFF', value: false }]

var selBasePosition = 1
var selTouchBase = true

function setBaseRunnerBaseballActionInfo(actionInfo) {
  setGlobalSettings = {
    ...actionInfo.payload.settings
  }

  if (actionInfo.payload.settings.hasOwnProperty('baseURL')) {
    baseURL = actionInfo.payload.settings.baseURL
  }

  if (actionInfo.payload.settings.hasOwnProperty(actionInfo.context)) {
    selBasePosition = actionInfo.payload.settings[actionInfo.context].position
    selTouchBase = actionInfo.payload.settings[actionInfo.context].touchBase
  }

  setDomByBaseRunnerBaseballAction()
}
function setDomByBaseRunnerBaseballAction() {
  document.getElementById('content').innerHTML = `
    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.scoreboard.basePosition} </div>
      <select class="sdpi-item-value select setvalueSelect" id="baseRunnerPositionSel">
      </select>
    </div>

    <div class="sdpi-item" id="select_combo">
      <div class="sdpi-item-label"> ${$PI.localization.scoreboard.onOff} </div>
      <select class="sdpi-item-value select setvalueSelect" id="baseRunnerTouchBaseSel">
      </select>
    </div>
  `;

  var reg_select = document.getElementById('baseRunnerPositionSel'); //找到select标签
  reg_select.innerHTML = ''
  var frag = document.createDocumentFragment(); //创建文档片段，文档片段的作用就是让for循环中创建的标签先放到文档片段中，待for循环结束后直接将文档片段插入制定的标签元素内，可以减少dom的操作
  for (var i = 0; i < basePositionList.length; i++) {
    var option = document.createElement("option"); //创建option标签
    option.value = basePositionList[i].value; //设置正在创建的option的value属性
    option.innerHTML = basePositionList[i].label
    if (selBasePosition === basePositionList[i].value) {
      option.selected = true
    }
    reg_select.appendChild(option); //将设置好的 option插入文档片段。
  }
  reg_select.appendChild(frag); //循环结束后一次性，将文档片段插入制定的dom中


  var position_reg_select = document.getElementById('baseRunnerTouchBaseSel'); //找到select标签
  position_reg_select.innerHTML = ''
  var frag = document.createDocumentFragment(); //创建文档片段，文档片段的作用就是让for循环中创建的标签先放到文档片段中，待for循环结束后直接将文档片段插入制定的标签元素内，可以减少dom的操作
  for (var i = 0; i < touchBaseList.length; i++) {
    var option = document.createElement("option"); //创建option标签
    option.value = touchBaseList[i].value; //设置正在创建的option的value属性
    option.innerHTML = touchBaseList[i].label
    if (selTouchBase === touchBaseList[i].value) {
      option.selected = true
    }
    position_reg_select.appendChild(option); //将设置好的 option插入文档片段。
  }
  position_reg_select.appendChild(frag); //循环结束后一次性，将文档片段插入制定的dom中

  const positionElement = document.getElementById('baseRunnerPositionSel');
  positionElement.addEventListener('change', baseRunnerPositionPlugin);


  const touchBaseElement = document.getElementById('baseRunnerTouchBaseSel');
  touchBaseElement.addEventListener('change', baseRunnerTouchBasePlugin);

}

function baseRunnerPositionPlugin(event) {
  const value = event.target.value

  oValueSelector && Array.prototype.forEach.call(oValueSelector.options, function (o) {
    const val = Math.round(value);
    if (o.value !== val) {
      oValueSelector.value = val;
    }
  })
  selBasePosition = value
  if ($PI) {
    const payload = {
      [actionInfo.context]: {
        position: value,
        touchBase: selTouchBase
      }
    }
    setGlobalSettings = {
      ...payload
    }
    setScoreboard()
  }
}

function baseRunnerTouchBasePlugin(event) {
  const value = event.target.value

  oValueSelector && Array.prototype.forEach.call(oValueSelector.options, function (o) {
    const val = Math.round(value);
    if (o.value !== val) {
      oValueSelector.value = val;
    }
  })

  selTouchBase = value
  if ($PI) {
    const payload = {
      [actionInfo.context]: {
        position: selBasePosition,
        touchBase: value
      }
    }
    setGlobalSettings = {
      ...payload
    }
    setScoreboard()
  }
}
// 跑垒设置 end==========================



// 设置足球记分牌补时时时间start==========================
var setStoppageTime = ''

// action 获取内部存储数据
function setStoppageTimeActionInfo(actionInfo) {
  setStoppageTime = actionInfo.payload.settings[actionInfo.context]
  setGlobalSettings = {
    ...actionInfo.payload.settings
  }

  if (actionInfo.payload.settings.hasOwnProperty('baseURL')) {
    baseURL = actionInfo.payload.settings.baseURL
  }

  setDomsetStoppageTimeAction()
}

function setDomsetStoppageTimeAction() {
  setScoreboard()

  document.getElementById('content').innerHTML = `
    <div type="range" class="sdpi-item">
      <div class="sdpi-item-label"> ${$PI.localization.scoreboard.min}</div>
      <div class="sdpi-item-value">
          <span class="clickable" value=0>0</span>
          <input class="floating-tooltip" data-suffix="min" type="range" id="game-Time-scoreboard-input" min="0" max="59" step="1" value="${setStoppageTime}">
          <span class="clickable" value="59">59</span>
      </div>
    </div>
  `;

  initToolTips();

  document.getElementById('game-Time-scoreboard-input').addEventListener('input', setStoppageTimeChanged);

}

function setStoppageTimeChanged(event) {
  const value = event.target.value
  setStoppageTime = value
  if ($PI) {
    const payload = {
      [actionInfo.context]: value
    }

    setGlobalSettings = {
      ...payload
    }

    setScoreboard()
  }
}

// 设置足球记分牌补时时时间 end==========================

