// var volumeTypeList = [
//     { value: '1',  label: 'Monitor' },
//     { value: '3',  label: 'Program' },
//     { value: '1792',  label: 'HDMI 1' },
//     { value: '2048',  label: 'HDMI 2' },
//     { value: '512',  label: 'Microphone' },
//     { value: '2',  label: 'Video Clip' },
//     { value: '768',  label: 'Bluetooth' },
//     { value: '1536',  label: 'BGM' },
//     { value: '0',  label: 'Stream' }
// ]
var volumeTypeList = []
var volumeStateList = [
    { value: '0',  label: 'Always ON' },
    { value: '1',  label: 'Always OFF' },
    { value: '2',  label: 'Audio Follow Video (AFV)' }
]

// 有afv得类型 HDMI 1,HDMI2,STREAM
var hasAfvType = ['1792', '2048', '0']

var volumeStateAfvList = [
    { value: '0',  label: 'Always on' },
    { value: '1',  label: 'Always off' },
    { value: '2',  label: 'Audio Follow Video (AFV)' }
]

var volumeMicOptList = [
    { value: 'true',  label: 'Audio On' },
    { value: 'false',  label: 'Audio Off' }
]

var volumeConfigList = null
var isVolumeConfigFirst = true
var volumeConfigId = ''

function volumeSetVolumeSetSettings() {
  let payloadP = {
      baseURL: baseURL
  }
  if (pluginAction === 'com.magewell.magewell-director.volume-set-volume') {
      payloadP = {
          ...payloadP,
          ...setGlobalSettings,
      }
  }

  $PI.send(uuid,
      'setSettings', {
          action: pluginAction,
          payload: payloadP || {}
      }, false)
}


function getStatemachineVolumeConfigChange(data) {
    if (isVolumeConfigFirst) {
      isVolumeConfigFirst = false
    }
    getVolumeConfigList()
}

async function getVolumeConfigList() {
  try {
    const response = await request('/V1.0/volume/getConfig');
    if (response.status === 0) {
      volumeConfigList = response.audioList;
      getVolumeList(volumeConfigList)
    }
  } catch (err) {
    console.error('Error fetching volume config list:', err);
    throw err;
  }
}


function getVolumeList(audioList) {
    const info = audioList

    const notAir = [1, 3] // 没有耳机
    const arr = []
    const typeInfo = {
      1: 'LISTENING',
      3: 'PROGRAM',
      513: 'MIC',
      1792: 'HDMI1',
      2048: 'HDMI2',
      2: 'VIDEO',
      8: 'VIDEO',
      1536: 'BGM',
      1537: 'BGM',
      528: 'USB Input Audio',
      538: 'USB Input Audio'
      // 256: 'SYTREMMIX',
      // 276: 'SYTREMMAX'  // 256-265 STR/RTMP   266-275 手机摄像头
      // 768: 'BLUETOOTH' 蓝牙
  }

    info.forEach((item, i) => {
      const obj = { ...item }
      let id = obj.audioSourceId

      obj.volumeNum = item.audioInfo.volume
      obj.meter.sort((a, b) => {
        return b - a
      })
      let meterVol = -88
      if (item.audioInfo.muted !== 1) {
        meterVol = obj.meter[0]
        const maxMeter = meterVol < -88 ? '---' : Math.round(meterVol) + 'dB'
        obj.maxMeter = maxMeter
      } else {
        meterVol = -100
        obj.maxMeter = '---'
      }

      // 没有耳机
      obj.notAir = notAir.indexOf(id) >= 0

      // 是否有vol
      obj.notVol = false

      // 副标题
      obj.subContent = ''

      // 是否显示隐藏音量
      obj.display = false

      // 是否支持video设置
      obj.hasFollowVideo = false
      // 当前源是否是视频
      obj.isVideo = false
      obj.videoName = ''
      if (item.audioSourceId >= 256 && item.audioSourceId <= 275) {
        // 网络流 srt rtmp 和 手机摄像头 FVarr
        obj.volName = item.audioInfo.label

        arr.push(obj)
        // i：2 时是麦克风
        if (i === 2) {
          obj.volName = 'MIC'
        } else {
          if (item.audioInfo.scope === 0) {
            obj.hasFollowVideo = true
          }
        }
      } else {
        if (item.audioSourceId !== 768) {
          // 当为监听时
          if (id === 1) {
            obj.notVol = true
            obj.subContent = 'Monitor'
          }

          obj.volName = Object.prototype.hasOwnProperty.call(typeInfo, obj.audioSourceId) ?
          $PI.localization.monitorDeviceName['audio-type-' + typeInfo[obj.audioSourceId]] : item.audioInfo.label

          if ((item.audioSourceId === 1792 || item.audioSourceId === 2048)) {
            if (item.audioInfo.scope === 0) {
              obj.hasFollowVideo = true
            }
          }

          // usb input audio
          if (item.audioSourceId >= 528 && item.audioSourceId <= 538) {
            obj.volName = 'USB AUDIO'
            obj.subContent = item.audioInfo.label
            if (item.audioInfo.scope === 0 && item.audioInfo.supportAFV) {
              obj.hasFollowVideo = true
            }
          }
          // 判断当前是否是视频
          if (item.audioSourceId === 2 || item.audioSourceId === 8) {
            obj.isVideo = true
            obj.videoName = item.audioInfo.label
            // obj.videoName = this.$utils.toVolumeSuffix(item.audioInfo.label)
          }
          // 当前选择的麦克风， 如果时HDMI1 1792 和 HDMI2 2048，则mic不展示
          // i：2 时是麦克风
          if (i === 2) {
            obj.volName = 'MIC'
          } else {
            // HDMI1 1792
            // if (
            //   this.selMic.audioSourceId === 1792 &&
            //   id === 1792 &&
            //   this.selMic.deviceType === 0
            // ) {
            //   obj.display = true
            // }
            // // HDMI2 2048
            // if (
            //   this.selMic.audioSourceId === 2048 &&
            //   id === 2048 &&
            //   this.selMic.deviceType === 0
            // ) {
            //   obj.display = true
            // }
          }
          // html gfx声音
          if (id >= 3072 && id <= 3080) {
            obj.notAir = true
            obj.subContent = `${obj.volName}`
            obj.volName = 'GFX'
          }
          arr.push(obj)
        } else {
          obj.volName = 'Bluetooth'
          obj.subContent = item.audioInfo.label
          obj.showArrow = false
          arr.push(obj)
        }
      }
      obj.volNumber = item.audioInfo.volume
      obj.airClass = item.audioInfo.solo ? 'vol-not-air' : 'vol-air'
      obj.mutedClass = item.audioInfo.muted === 1 ? 'vol-mute' : 'vol-not-mute'

      // 3.0之后的版本 sourceType srt 10-19  rtmp: 20-29  ndi: 42-51 rtsp: 55-64
      if (Object.prototype.hasOwnProperty.call(item.audioInfo, 'sourceType')) {
        const sourceTypeVal = item.audioInfo.sourceType
        if (sourceTypeVal >= 10 && sourceTypeVal <= 19) {
          obj.volName =`SRT-${obj.volName}`
        } else if (sourceTypeVal >= 20 && sourceTypeVal <= 29) {
          obj.volName = `RTMP-${obj.volName}`
        } else if (sourceTypeVal >= 42 && sourceTypeVal <= 51) {
          obj.volName = `NDI-${obj.volName}`
        } else if (sourceTypeVal >= 55 && sourceTypeVal <= 64) {
          obj.volName = `RTSP-${obj.volName}`
        } else if (sourceTypeVal === 54) {
          if (!item.audioInfo.isGFX) {
            // 场景 html
            obj.volName = `Webpage-${item.audioInfo.name}`

            if (item.audioInfo.scope === 0 && item.audioInfo.supportAFV) {
              obj.hasFollowVideo = true
            }
          }
        }
      }

      if (item.audioInfo.isGFX) {
        obj.notAir = true
        obj.hasFollowVideo = false
        if (Object.prototype.hasOwnProperty.call(item.audioInfo, 'sourceType')) {
          const sourceTypeVal = item.audioInfo.sourceType
          if (sourceTypeVal >= 42 && sourceTypeVal <= 51) {
            // ndi gfx
            obj.volName = `NDI GFX-${item.audioInfo.name}`
          }

          if (sourceTypeVal === 54) {
            // gfx html
            obj.volName = `WEB GFX-${item.audioInfo.name}`
          }
        }
      }
    })
    volumeTypeList = [...arr]
  }


function volumeSetVolumeActionGetInfo(actionInfo) {
    const { context, payload } = actionInfo;

    if(!payload.settings[context]) {
        payload.settings[context] = {
            'volumeType': '3',
            'volumeValue': '0',
        }
    }

    volumeType = payload.settings[context].volumeType
    volumeSetValue = payload.settings[context].volumeValue

    setGlobalSettings = {
        ...payload.settings
    }
    if (payload.settings.hasOwnProperty('baseURL')) {
        baseURL = payload.settings.baseURL
    }

    volumeSetVolumeSetDom()
}
function volumeSetVolumeSetDom() {
    volumeSetVolumeSetSettings()
    document.getElementById('content').innerHTML = `
        <div class="sdpi-item" id="select_combo">
            <div class="sdpi-item-label"> Volume Name </div>
            <select class="sdpi-item-value select eventSetvalueSelect" id="volumeListOptionSel"></select>
        </div>
        <div type="range" class="sdpi-item">
          <div class="sdpi-item-label" [data-localize]="volume"> Volume</div>
          <div class="sdpi-item-value">
              <span class="clickable" value=-40>-40</span>
              <input class="floating-tooltip" data-suffix="dB" type="range" id="volumeOptionSel" min="-40" max="10" step="1" value="${volumeSetValue}">
              <span class="clickable" value="10">10</span>
          </div>
        </div>
    `;

    initToolTips();
    const typeOptionElement = document.getElementById('volumeListOptionSel');
    typeOptionElement.addEventListener('change', volumeSetVolumeSendValueToPlugin);
    const volumeOptionSelElement = document.getElementById('volumeOptionSel');
    volumeOptionSelElement.addEventListener('input', volumeSetVolumeValuesSendValueToPlugin);
    volumeSetVolumeCreatedOption()
}

function volumeSetVolumeCreatedOption() {
  if (volumeTypeList.length === 0) {
    setTimeout(() => {
      volumeSetVolumeCreatedOption()
    }, 500)
    return
  }

  var volumeListOptionSelEle = document.getElementById('volumeListOptionSel'); //找到select标签
  volumeListOptionSelEle.innerHTML = ''
  var frag = document.createDocumentFragment(); //创建文档片段，文档片段的作用就是让for循环中创建的标签先放到文档片段中，待for循环结束后直接将文档片段插入制定的标签元素内，可以减少dom的操作
  for (let i = 0; i < volumeTypeList.length; i++) {
      let item = volumeTypeList[i];
      let option = document.createElement("option"); //创建option标签
      option.value = item.audioInfo.type; //设置正在创建的option的value属性
      option.innerHTML = item.volName
      if (volumeType === item.value) {
          option.selected = true
      }
      volumeListOptionSelEle.appendChild(option); //将设置好的 option插入文档片段。
  }
  volumeListOptionSelEle.appendChild(frag); //循环结束后一次性，将文档片段插入制定的dom中
}
function volumeSetVolumeSendValueToPlugin(event) {
    const value = event.target.value
    volumeType = value;

    if ($PI) {
        const payload = {
            [actionInfo.context]: {
                volumeType: volumeType,
                volumeValue: volumeSetValue
            }
        }

        setGlobalSettings = {
            ...payload
        }

        volumeSetVolumeSetSettings()
    }
}
function volumeSetVolumeValuesSendValueToPlugin(event) {
    const value = event.target.value
    volumeSetValue = value;
    if ($PI) {
        const payload = {
            [actionInfo.context]: {
                volumeType: volumeType,
                volumeValue: volumeSetValue
            }
        }

        setGlobalSettings = {
            ...payload
        }

        volumeSetVolumeSetSettings()
    }
}


// 设置音量volume end





// 设置音量volume 静音start

function volumeSetStateActionGetInfo(actionInfo) {
  const { context, payload } = actionInfo;
  console.log('replay actionINfo', actionInfo)

  if(!payload.settings[context]) {
      payload.settings[context] = {
          'volumeType': '3',
          'volumeState': '2',
      }
  }

  volumeType = payload.settings[context].volumeType
  volumeState = payload.settings[context].volumeState

  setGlobalSettings = {
      ...payload.settings
  }
  if (payload.settings.hasOwnProperty('baseURL')) {
      baseURL = payload.settings.baseURL
  }

  volumeSetStateSetDom()
}
function volumeSetStateSetDom() {
  volumeSetStateSetSettings()


  document.getElementById('content').innerHTML = `
      <div class="sdpi-item" id="select_combo">
          <div class="sdpi-item-label"> Volume Name </div>
          <select class="sdpi-item-value select eventSetvalueSelect" id="volumeStateOptionSel"></select>
      </div>
      <div class="sdpi-item" id="select_combo2">
          <div class="sdpi-item-label" [data-localize]="state"> State </div>
          <select class="sdpi-item-value select eventSetvalueSelect" id="stateOptionSel"></select>
      </div>
  `;

  initToolTips();
  const typeOptionElement = document.getElementById('volumeStateOptionSel');
  typeOptionElement.addEventListener('change', volumeStateSetTypeSendValueToPlugin);
  const stateOptionSelElement = document.getElementById('stateOptionSel');
  stateOptionSelElement.addEventListener('change', volumeStateSetStateSendValueToPlugin);
  volumeSetStateCreatedOption()
}
function volumeStateSetTypeSendValueToPlugin(event) {
  const value = event.target.value
  volumeType = value;
  if ($PI) {
      const payload = {
          [actionInfo.context]: {
              volumeType: volumeType,
              volumeState: volumeState
          }
      }

      setGlobalSettings = {
          ...payload
      }

      volumeSetStateSetSettings()
  }
}
function volumeStateSetStateSendValueToPlugin(event) {
  const value = event.target.value
  volumeState = value;
  if ($PI) {
      const payload = {
          [actionInfo.context]: {
              volumeType: volumeType,
              volumeState: volumeState
          }
      }

      setGlobalSettings = {
          ...payload
      }

      volumeSetStateSetSettings()
  }
}
function volumeSetStateCreatedOption() {
  if (volumeTypeList.length === 0) {
    setTimeout(() => {
      volumeSetStateCreatedOption()
    }, 500)
    return
  }
  var volumeStateSelEle = document.getElementById('volumeStateOptionSel'); //找到select标签
  var stateOptionSelEle = document.getElementById('stateOptionSel'); //找到select标签
  volumeStateSelEle.innerHTML = ''
  stateOptionSelEle.innerHTML = ''
  var frag = document.createDocumentFragment(); //创建文档片段，文档片段的作用就是让for循环中创建的标签先放到文档片段中，待for循环结束后直接将文档片段插入制定的标签元素内，可以减少dom的操作
  for (let i = 0; i < volumeTypeList.length; i++) {
      let item = volumeTypeList[i];
      let option = document.createElement("option"); //创建option标签
      option.value = item.audioInfo.type; //设置正在创建的option的value属性
      option.innerHTML = item.volName
      if (volumeType === item.value) {
          option.selected = true
      }
      volumeStateSelEle.appendChild(option); //将设置好的 option插入文档片段。
  }
  volumeStateSelEle.appendChild(frag); //循环结束后一次性，将文档片段插入制定的dom中


  var frag2 = document.createDocumentFragment(); //创建文档片段，文档片段的作用就是让for循环中创建的标签先放到文档片段中，待for循环结束后直接将文档片段插入制定的标签元素内，可以减少dom的操作
  for (let i = 0; i < volumeStateList.length; i++) {
      let item = volumeStateList[i];
      let option = document.createElement("option"); //创建option标签
      option.value = item.value; //设置正在创建的option的value属性
      option.innerHTML = item.label
      if (volumeState === item.value) {
          option.selected = true
      }
      frag2.appendChild(option); //将设置好的 option插入文档片段。
  }
  stateOptionSelEle.appendChild(frag2); //循环结束后一次性，将文档片段插入制定的dom中
}
function volumeSetStateSetSettings() {
  let payloadP = {
      baseURL: baseURL
  }
  if (pluginAction === 'com.magewell.magewell-director.volume-set-state') {
      payloadP = {
          ...payloadP,
          ...setGlobalSettings,
      }
  }

  $PI.send(uuid,
      'setSettings', {
          action: pluginAction,
          payload: payloadP || {}
      }, false)
}


// 设置音量volume 静音END



// SET MONITOR DEVICE START
let monitorDevicesList = null;
let monitorDeviceInfo = {};
let audioMixerFirst = true;


async function getMonitorDevicesList() {
  try {
      const response = await request('/V1.0/volume/getMonitorDevices');
      if (response.status === 0) {
          monitorDevicesList = response.monitorAudioDeivceList;
      }
  } catch (err) {
      console.error('Error getMonitorDevicesList:', err);
      throw err;
  }
}

function volumeSetMonitorDeviceActionGetInfo(actionInfo) {
  const { context, payload } = actionInfo;
  console.log('replay actionINfo', actionInfo)
  if(payload.settings[context]) {
      monitorDeviceInfo = payload.settings[context];
  }
  setGlobalSettings = {
      ...payload.settings
  }
  if (payload.settings.hasOwnProperty('baseURL')) {
      baseURL = payload.settings.baseURL
  }

  if (payload.settings.hasOwnProperty('monitorDevicesList')) {
    monitorDevicesList = payload.settings.monitorDevicesList
  } else {
    this.getMonitorDevicesList()
  }


  volumeSetMonitorDeviceSetDom()
}
function volumeSetMonitorDeviceSetDom() {
  if (monitorDevicesList === null) {
      setTimeout(() => {
          volumeSetMonitorDeviceSetDom()
      }, 500)
      return
  }

  volumeSetMonitorDeviceSetSettings()
  document.getElementById('content').innerHTML = `
      <div class="sdpi-item" id="select_combo">
          <div class="sdpi-item-label" [data-localize]="label">Option</div>
          <select class="sdpi-item-value select setvalueSelect" id="volumeSetMonitorDeviceSet"></select>
      </div>
  `;
  const element = document.getElementById('volumeSetMonitorDeviceSet');
  element.addEventListener('change', volumeSetMonitorDeviceSendValueToPlugin);
  volumeSetMonitorDeviceCreatedOption()
}
function volumeSetMonitorDeviceSendValueToPlugin(event) {
  const value = event.target.value
  console.log(value);

  for(let i =0; i< monitorDevicesList.length; i++){
      let item = monitorDevicesList[i];
      let tempId = item.id + '';
      if(tempId === value) {
          monitorDeviceInfo = item;
      }
  }
  console.log('volumeSetMonitorDeviceSendValueToPlugin', monitorDeviceInfo)


  if ($PI) {
      const payload = {
          [actionInfo.context]: monitorDeviceInfo
      }

      setGlobalSettings = {
          ...payload
      }

      volumeSetMonitorDeviceSetSettings()
  }
}
function volumeSetMonitorDeviceCreatedOption() {
  var reg_select = document.getElementById('volumeSetMonitorDeviceSet'); //找到select标签
  reg_select.innerHTML = ''
  var frag = document.createDocumentFragment(); //创建文档片段，文档片段的作用就是让for循环中创建的标签先放到文档片段中，待for循环结束后直接将文档片段插入制定的标签元素内，可以减少dom的操作
  for (let i = 0; i < monitorDevicesList.length; i++) {
      let item = monitorDevicesList[i];
      let name =  item.deviceType === 1 ? item.name : $PI.localization.monitorDeviceName['audio-source-' + item.audioSourceId];
      var option = document.createElement("option"); //创建option标签
      option.value = item.id; //设置正在创建的option的value属性
      option.innerHTML =  name;
      if (Object.keys(monitorDeviceInfo).length !== 0 && monitorDeviceInfo.id === item.id) {
          option.selected = true
      }
      reg_select.appendChild(option); //将设置好的 option插入文档片段。
  }
  reg_select.appendChild(frag); //循环结束后一次性，将文档片段插入制定的dom中
}
function volumeSetMonitorDeviceSetSettings() {
  let payloadP = {
      baseURL: baseURL
  }
  if (pluginAction === 'com.magewell.magewell-director.volume-set-monitor-device') {
      payloadP = {
          ...payloadP,
          ...setGlobalSettings,
          monitorDevicesList: monitorDevicesList
      }
  }

  $PI.send(uuid,
      'setSettings', {
          action: pluginAction,
          payload: payloadP || {}
      }, false)
}

function volumeMonitorMicInputActionGetInfo(actionInfo) {
  const { context, payload } = actionInfo;
  console.log('replay actionINfo', actionInfo)
  if(!payload.settings[context]) {
      payload.settings[context] = 'false';
  }
  volumeSetValue = payload.settings[context]
  setGlobalSettings = {
      ...payload.settings
  }
  if (payload.settings.hasOwnProperty('baseURL')) {
      baseURL = payload.settings.baseURL
  }

  volumeMonitorMicInputSetDom()
}
function volumeMonitorMicInputSetDom() {
  volumeMonitorMicInputSetSettings()
  document.getElementById('content').innerHTML = `
      <div class="sdpi-item" id="select_combo">
          <div class="sdpi-item-label" [data-localize]="label">Option</div>
          <select class="sdpi-item-value select setvalueSelect" id="volumeMonitorMicInputSet"></select>
      </div>
  `;
  const element = document.getElementById('volumeMonitorMicInputSet');
  element.addEventListener('change', volumeMonitorMicInputSendValueToPlugin);
  volumeMonitorMicInputCreatedOption()
}
function volumeMonitorMicInputCreatedOption() {
  var reg_select = document.getElementById('volumeMonitorMicInputSet'); //找到select标签
  reg_select.innerHTML = ''
  var frag = document.createDocumentFragment(); //创建文档片段，文档片段的作用就是让for循环中创建的标签先放到文档片段中，待for循环结束后直接将文档片段插入制定的标签元素内，可以减少dom的操作
  for (let i = 0; i < volumeMicOptList.length; i++) {
      let item = volumeMicOptList[i];
      var option = document.createElement("option"); //创建option标签
      option.value = item.value; //设置正在创建的option的value属性
      option.innerHTML = item.label
      if (volumeSetValue === item.value) {
          option.selected = true
      }
      reg_select.appendChild(option); //将设置好的 option插入文档片段。
  }
  reg_select.appendChild(frag); //循环结束后一次性，将文档片段插入制定的dom中
}
function volumeMonitorMicInputSendValueToPlugin(event) {
  const value = event.target.value

  if ($PI) {
      const payload = {
          [actionInfo.context]: value
      }

      setGlobalSettings = {
          ...payload
      }

      volumeMonitorMicInputSetSettings()
  }
}
function volumeMonitorMicInputSetSettings() {
  let payloadP = {
      baseURL: baseURL
  }
  if (pluginAction === 'com.magewell.magewell-director.volume-monitor-mic-input') {
      payloadP = {
          ...payloadP,
          ...setGlobalSettings,
      }
  }

  $PI.send(uuid,
      'setSettings', {
          action: pluginAction,
          payload: payloadP || {}
      }, false)
}

// SET MONITOR DEVICE END
