/// <reference path="libs/js/action.js" />
/// <reference path="libs/js/stream-deck.js" />

/**
 * The first event fired when Stream Deck starts
 */

$SD.getGlobalSettings()
console.log('getGlobalSettings--sd', $SD)

$SD.onDidReceiveGlobalSettings((e) => {
  const payload = e.payload
  const setting = payload.settings
  if (setting.hasOwnProperty('baseURL') && setting.baseURL) {
    baseURL = setting.baseURL
  }
})
const clientId = Date.now()
var statemachineInfo = {}
var volumeConfigList = []
var ACTION = {}

getStatemachine()
getVolumeConfigRequest()

function getStatemachine() {
    if (baseURL) {
        request('/mwapi/statemachine', {
            body: {
                client: clientId
            }
        }).then(data => {
            if (data.status === 0) {
              statemachineInfo = data
            }
            this.delayGetStatemachine()
        }).catch(err => {
            this.delayGetStatemachine()
        });
    } else {
      this.delayGetStatemachine()
    }

}

function delayGetStatemachine() {
    setTimeout(() => {
        getStatemachine()
    }, 1000)
}

function delayVolumeConfigRequest() {
  setTimeout(() => {
    getVolumeConfigRequest()
  }, 1000)
}

function getVolumeConfigRequest() {
  if (baseURL) {
    request('/V1.0/volume/getConfig')
      .then(data => {
          if (data.status === 0) {
            volumeConfigList = data.audioList
          }
          this.delayVolumeConfigRequest()
      }).catch(err => {
          this.delayVolumeConfigRequest()
      });
  } else {
    this.delayVolumeConfigRequest()
  }

}